import 'package:json_annotation/json_annotation.dart';

part 'inforesponselimits.g.dart';

@JsonSerializable()
class CatalogInfoResponseLimits {
  @JsonValue('batch_upsert_max_objects_per_batch')
  final int batchUpsertMaxObjectsPerBatch;

  @JsonValue('batch_upsert_max_total_per_batch')
  final int batchUpsertMaxTotalPerBatch;

  @JsonValue('batch_retrieve_max_object_ids')
  final int batchRetrieveMaxObjectIds;

  @JsonValue('search_max_page_limit')
  final int searchMaxPageLimit;

  @JsonValue('batch_delete_max_object_ids')
  final int batchDeleteMaxObjectIds;

  @JsonValue('update_item_taxes_max_item_ids')
  final int updateItemYaxesMaxItemIds;

  @JsonValue('update_item_taxes_max_taxes_to_enable')
  final int updateItemTaxesMaxTaxesToEnable;

  @JsonValue('update_item_taxes_max_taxes_to_disable')
  final int updateItemTaxesMaxTaxesToDisable;

  @JsonValue('update_item_modifier_lists_max_item_ids')
  final int updateItemModifierListsMaxItemIds;

  @JsonValue('update_item_modifier_lists_max_modifier_lists_to_enable')
  final int updateItemModifierListsMaxModifierListsToEnable;

  @JsonValue('update_item_modifier_lists_max_modifier_lists_to_disable')
  final int updateItemModifierListsMaxModifierListsToDisable;

  CatalogInfoResponseLimits({this.batchUpsertMaxObjectsPerBatch, 
                             this.batchUpsertMaxTotalPerBatch, 
                             this.batchRetrieveMaxObjectIds, 
                             this.searchMaxPageLimit, 
                             this.batchDeleteMaxObjectIds, 
                             this.updateItemYaxesMaxItemIds, 
                             this.updateItemTaxesMaxTaxesToEnable, 
                             this.updateItemTaxesMaxTaxesToDisable, 
                             this.updateItemModifierListsMaxItemIds, 
                             this.updateItemModifierListsMaxModifierListsToEnable, 
                             this.updateItemModifierListsMaxModifierListsToDisable});
  
  factory CatalogInfoResponseLimits.fromJson(Map<String, dynamic> json) => _$CatalogInfoResponseLimitsFromJson(json);
  Map<String, dynamic> toJson() => _$CatalogInfoResponseLimitsToJson(this);  
}