import 'package:json_annotation/json_annotation.dart';
import 'package:dart_square/shared.dart';

part 'itemvariation.g.dart';

@JsonSerializable()
class CatalogItemVariation {
  @JsonValue('item_id')
  final String itemId;
  final String name;
  final String sku;
  final String upc;
  final int ordinal;
  @JsonValue('pricing_type')
  final String pricingType;
  @JsonValue('price_money')
  final Money priceMoney;
  @JsonValue('location_overrides')
  final List<ItemVariationLocationOverrides> locationOverrides;
  @JsonValue('track_inventory')
  final bool trackInventory;
  @JsonValue('inventory_alert_type')
  final String inventoryAlertType;
  @JsonValue('inventory_alert_threshold')
  final int inventoryAlertThreshold;
  @JsonValue('user_data')
  final String userData;
  @JsonValue('service_duration')
  final int serviceDuration;

  CatalogItemVariation({this.itemId, this.name, this.sku, this.upc, this.ordinal, this.pricingType, this.priceMoney, this.locationOverrides, this.trackInventory, this.inventoryAlertType, this.inventoryAlertThreshold, this.userData, this.serviceDuration});

  factory CatalogItemVariation.fromJson(Map<String, dynamic> json) => _$CatalogItemVariationFromJson(json);
  Map<String, dynamic> toJson() => _$CatalogItemVariationToJson(this);
}

@JsonSerializable()
class ItemVariationLocationOverrides {
  @JsonValue('location_id')
  final String locationId;
  @JsonValue('price_money')
  final Money priceMoney;
  @JsonValue('pricing_type')
  final String pricingType;
  @JsonValue('track_inventory')
  final bool trackInventory;
  @JsonValue('inventory_alert_type')
  final String inventoryAlertType;
  @JsonValue('inventory_alert_threshold')
  final int inventoryAlertThreshold;

  ItemVariationLocationOverrides({this.locationId, this.priceMoney, this.pricingType, this.trackInventory, this.inventoryAlertType, this.inventoryAlertThreshold});

  factory ItemVariationLocationOverrides.fromJson(Map<String, dynamic> json) => _$ItemVariationLocationOverridesFromJson(json);
  Map<String, dynamic> toJson() => _$ItemVariationLocationOverridesToJson(this);
}