import "package:json_annotation/json_annotation.dart";
import 'category.dart';
import 'discount.dart';
import 'item.dart';
import 'itemvariation.dart';
import 'modifier.dart';
import 'modifierlist.dart';
import 'tax.dart';

part 'object.g.dart';

@JsonSerializable()
class CatalogObject {
  final String type;
  final String id;
  @JsonValue('updated_at')
  final String updatedAt;
  final int version;
  @JsonValue('is_deleted')
  final bool isDeleted;
  @JsonValue('present_at_all_locations')
  final bool presentAtAllLocations;
  @JsonValue('present_at_location_ids')
  final List<String> presentAtLocationIds;
  @JsonValue('absent_at_location_ids')
  final List<String> absentAtLocationIds;
  @JsonValue('item_data')
  final CatalogItem itemData;
  @JsonValue('category_data')
  final CatalogCategory categoryData;
  @JsonValue('item_variation_data')
  final CatalogItemVariation itemVariationData;
  @JsonValue('tax_data')
  final CatalogTax taxData;
  @JsonValue('discount_data')
  final CatalogDiscount discountData;
  @JsonValue('modifier_list_data')
  final CatalogModifierList modifierListData;
  @JsonValue('modifier_data')
  final CatalogModifier modifierData;

  CatalogObject({this.type, this.id, this.updatedAt, this.version, this.isDeleted, this.itemData, this.categoryData,
                 this.presentAtAllLocations, this.presentAtLocationIds, this.absentAtLocationIds, this.itemVariationData, 
                 this.taxData, this.discountData, this.modifierListData, this.modifierData});
                 
  factory CatalogObject.fromJson(Map<String, dynamic> json) => _$CatalogObjectFromJson(json);
  Map<String, dynamic> toJson() => _$CatalogObjectToJson(this);
}