import 'package:dart_square/src/catalog/models/models.dart';
import 'package:json_annotation/json_annotation.dart';

part 'search.g.dart';

@JsonSerializable()
class SearchCatalogsRequest {
  String cursor;
  @JsonValue('object_types')
  List<String> objectTypes;
  @JsonValue('include_deleted_objects')
  bool includeDeletedObjects;
  @JsonValue('include_related_objects')
  bool includeRelatedObjects;
  @JsonValue('begin_time')
  String beginTime;
  CatalogQuery query;
  int limit;

  SearchCatalogsRequest({this.cursor, this.objectTypes, this.includeDeletedObjects, 
                         this.includeRelatedObjects, this.beginTime, this.query, 
                         this.limit});

  factory SearchCatalogsRequest.fromJson(Map<String, dynamic> json) => _$SearchCatalogsRequestFromJson(json);
  Map<String, dynamic> toJson() => _$SearchCatalogsRequestToJson(this);
}