import 'package:json_annotation/json_annotation.dart';
import 'package:dart_square/shared.dart';
import '../models/object.dart';

part 'batchretrieve.g.dart';

@JsonSerializable()
class BatchRetrieveResponse {
  final List<SquareError> errors;
  final List<CatalogObject> objects;
  @JsonValue('related_objects')
  final List<CatalogObject> relatedObjects;

  BatchRetrieveResponse({this.errors, this.objects, this.relatedObjects});

  factory BatchRetrieveResponse.fromJson(Map<String, dynamic> json) => _$BatchRetrieveResponseFromJson(json);
  Map<String, dynamic> toJson() => _$BatchRetrieveResponseToJson(this);
}
