import 'package:dart_square/src/catalog/models/models.dart';
import 'package:json_annotation/json_annotation.dart';
import 'package:dart_square/shared.dart';

part 'batchupsert.g.dart';

@JsonSerializable()
class BatchUpsertResponse {
  final List<SquareError> errors;
  final List<CatalogObject> objects;
  @JsonValue('updated_at')
  final String updatedAt;
  @JsonValue('id_mappings')
  final List<CatalogIdMapping> idMappings;

  BatchUpsertResponse({this.errors, this.objects, this.updatedAt, this.idMappings});

  factory BatchUpsertResponse.fromJson(Map<String, dynamic> json) => _$BatchUpsertResponseFromJson(json);
  Map<String, dynamic> toJson() => _$BatchUpsertResponseToJson(this);
}
