import 'package:dart_square/src/catalog/models/models.dart';
import 'package:json_annotation/json_annotation.dart';
import 'package:dart_square/shared.dart';

part 'search.g.dart';

@JsonSerializable()
class SearchCatalogsResponse {
  final List<SquareError> errors;
  final String cursor;
  final List<CatalogObject> objects;
  @JsonValue('related_objects')
  final List<CatalogObject> relatedObjects;

  SearchCatalogsResponse({this.errors, this.cursor, this.objects, this.relatedObjects});

  factory SearchCatalogsResponse.fromJson(Map<String, dynamic> json) => _$SearchCatalogsResponseFromJson(json);
  Map<String, dynamic> toJson() => _$SearchCatalogsResponseToJson(this);
}