import 'dart:async';
import 'dart:convert';
import 'package:http/http.dart';
import 'package:dart_square/src/checkout/requests/requests.dart';
import 'package:dart_square/src/checkout/responses/create.dart';
import 'package:reflutter/reflutter.dart';

export 'requests/requests.dart';
export 'responses/responses.dart';

part 'checkout.api.dart';

@ReflutterHttp(name: 'SquareCheckout')
abstract class _SquareCheckoutEndpoint {
  @Post('/v2/locations/:locationId/checkouts')
  Future<ReflutterResponse<CreateCheckoutResponse>> create(
    @Param("location_id") String locationId, 
    @Body() CreateCheckoutRequest body
  );
}