import 'dart:async';
import 'dart:convert';
import 'package:http/http.dart';
import 'package:reflutter/reflutter.dart';
import 'responses/responses.dart';
import 'requests/requests.dart';

export 'responses/responses.dart';
export 'requests/requests.dart';

part 'orders.api.dart';

@ReflutterHttp(name: 'SquareOrders')
abstract class _SquareOrdersEndpoint {
  
  @Post('/v2/locations/:locationId/orders/batch-retrieve')
  Future<ReflutterResponse<OrderResponse>> batchRetrieve(
    @Param('location_id') String locationId,
    @Body() OrderRequest req
  );

  @Post('/v2/locations/:locationId/orders')
  Future<ReflutterResponse<CreateOrderResponse>> create(
    @Param('location_id') String locationId,
    @Body() CreateOrderRequest req
  );
}