import 'dart:async';
import 'dart:convert';
import 'package:http/http.dart';
import 'package:reflutter/reflutter.dart';
import 'responses/responses.dart';

export 'responses/responses.dart';

part 'reporting.api.dart';

@ReflutterHttp(name: 'SquareTransactions')
abstract class _SquareReportingEndpoint {

  @Get('/v2/locations/:locationId/additional-recipient-receivables')
  Future<ReflutterResponse<AdditionalReceivablesResponse>> listAdditionalRecipientReceivables(
    @Param('location_id') String locationId,
    @QueryParam('begin_time') String beginTime,
    @QueryParam('end_time') String endTime,
    @QueryParam('sort_order') String sortOrder,
    @QueryParam() String cursor
  );

  @Post('/v2/locations/:locationId/transactions')
  Future<ReflutterResponse<AdditionalRefundsResponse>> listAdditionalRecipientReceivableRefunds(
    @Param("location_id") String locationId,
    @QueryParam('begin_time') String beginTime,
    @QueryParam('end_time') String endTime,
    @QueryParam('sort_order') String sortOrder,
    @QueryParam() String cursor
  );

}