import 'package:json_annotation/json_annotation.dart';
import 'money.dart';

part 'additionalrecipient.g.dart';

@JsonSerializable()
class AdditionalRecipient {
  @JsonValue('location_id')
  final String locationId;
  final String description;
  @JsonValue('amount_money')
  final Money amountMoney;
  @JsonValue('receivable_id')
  final String receivableId;

  AdditionalRecipient({ this.locationId, this.description, this.amountMoney, this.receivableId });

  factory AdditionalRecipient.fromJson(Map<String, dynamic> json) => _$AdditionalRecipientFromJson(json);
  Map<String, dynamic> toJson() => _$AdditionalRecipientToJson(this);
}

@JsonSerializable()
class AdditionalRecipientReceivable {
  String id;
  @JsonValue('transaction_id')
  String transactionId;
  @JsonValue('transaction_location_id')
  String transactionLocationId;
  @JsonValue('amount_money')
  Money amount;
  @JsonValue('created_at')
  String createdAt;
  List<AdditionalRecipientReceivableRefund> refunds;

  AdditionalRecipientReceivable({this.id, this.transactionId, 
    this.transactionLocationId, this.amount, this.createdAt });

  factory AdditionalRecipientReceivable.fromJson(Map<String, dynamic> json) => _$AdditionalRecipientReceivableFromJson(json);
  Map<String, dynamic> toJson() => _$AdditionalRecipientReceivableToJson(this);
}

@JsonSerializable()
class AdditionalRecipientReceivableRefund {
  String id;
  @JsonValue('receivable_id')
  String receivableId;
  @JsonValue('refund_id')
  String refundId;
  @JsonValue('transaction_location_id')
  String transactionLocationId;
  @JsonValue('amount_money')
  Money amount;
  @JsonValue('created_at')
  String createdAt;

  AdditionalRecipientReceivableRefund({ this.id, this.receivableId, 
    this.refundId, this.transactionLocationId, this.amount, this.createdAt });

  factory AdditionalRecipientReceivableRefund.fromJson(Map<String, dynamic> json) => _$AdditionalRecipientReceivableRefundFromJson(json);
  Map<String, dynamic> toJson() => _$AdditionalRecipientReceivableRefundToJson(this);
}