import 'package:json_annotation/json_annotation.dart';

part 'address.g.dart';

@JsonSerializable()
class Address {
  @JsonValue('address_line_1')
  String address1;
  @JsonValue('address_line_2')
  String address2;
  @JsonValue('address_line_3')
  String address3;
  String locality;
  String sublocality;
  String sublocality_2;
  String sublocality_3;
  @JsonValue('administrative_district_level_1')
  String adminDistrict1;
  @JsonValue('administrative_district_level_2')
  String adminDistrict2;
  @JsonValue('administrative_district_level_3')
  String adminDistrict3;
  @JsonValue('postal_code')
  String postalCode;
  String country;
  @JsonValue('first_name')
  String firstName;
  @JsonValue('last_name')
  String lastName;
  String organization;

  Address({ this.address1, this.address2, this.address3, 
            this.locality, this.sublocality, this.sublocality_2, this.sublocality_3, 
            this.adminDistrict1, this.adminDistrict2, 
            this.adminDistrict3, this.postalCode, this.country, 
            this.firstName, this.lastName, this.organization });

  factory Address.fromJson(Map<String, dynamic> json) => _$AddressFromJson(json);
  Map<String, dynamic> toJson() => _$AddressToJson(this);
}