import 'package:dart_square/shared.dart';
import 'package:json_annotation/json_annotation.dart';

part 'card.g.dart';

@JsonSerializable()
class Card {
  String id;
  @JsonValue('card_brand')
  String cardBrand;
  @JsonValue('last_4')
  String last4;
  @JsonValue('exp_value')
  int expMonth;
  @JsonValue('exp_year')
  int expYear;
  @JsonValue('cardholder_name')
  String cardholderName;
  @JsonValue('billing_address')
  Address billingAddress;
  String fingerprint;

  Card({this.id, this.cardBrand, this.last4, this.expMonth, 
    this.expYear, this.cardholderName, this.billingAddress, this.fingerprint});
  
  factory Card.fromJson(Map<String, dynamic> json) => _$CardFromJson(json);
  Map<String, dynamic> toJson() => _$CardToJson(this); 
}