import 'package:dart_square/shared.dart';
import 'package:json_annotation/json_annotation.dart';

part 'charge.g.dart';

@JsonSerializable()
class ChargeRequest {
  @JsonValue("idempotency_key")
  final String idempotencyKey;
  @JsonValue("amount_money")
  final Money amountMoney;
  @JsonValue("card_nonce")
  final String cardNonce;
  @JsonValue("customer_card_id")
  final String customerCardId;
  @JsonValue("delay_capture")
  final bool delayCapture;
  @JsonValue("reference_id")
  final String referenceId;
  final String note;
  @JsonValue("customer_id")
  final String customerId;
  @JsonValue("billing_address")
  final Address billingAddress;
  @JsonValue("shipping_address")
  final Address shippingAddress;
  @JsonValue("buyer_email_address")
  final String buyerEmailAddress;
  @JsonValue("order_id")
  final String orderId;
  @JsonValue("additional_recipients")
  final List<AdditionalRecipient> additionalRecipients;

  ChargeRequest(this.idempotencyKey, this.amountMoney, { this.cardNonce, 
    this.customerCardId, this.delayCapture, this.referenceId, 
    this.note, this.customerId, this.billingAddress, this.shippingAddress, 
    this.buyerEmailAddress, this.orderId, this.additionalRecipients});

  factory ChargeRequest.fromJson(Map<String, dynamic> json) => _$ChargeRequestFromJson(json);
  Map<String, dynamic> toJson() => _$ChargeRequestToJson(this);
}