import 'package:dart_square/shared.dart';
import 'package:json_annotation/json_annotation.dart';

part 'refund.g.dart';

@JsonSerializable()
class CreateRefundResponse {
  final List<SquareError> errors;
  final Refund refund;

  CreateRefundResponse({ this.errors, this.refund });

  factory CreateRefundResponse.fromJson(Map<String, dynamic> json) => _$CreateRefundResponseFromJson(json);
  Map<String, dynamic> toJson() => _$CreateRefundResponseToJson(this);
}

@JsonSerializable()
class ListRefundResponse {
  final List<SquareError> errors;
  final List<Refund> refunds;
  final String cursor;

  ListRefundResponse({ this.errors, this.refunds, this.cursor });

  factory ListRefundResponse.fromJson(Map<String, dynamic> json) => _$ListRefundResponseFromJson(json);
  Map<String, dynamic> toJson() => _$ListRefundResponseToJson(this);
}