import 'package:json_annotation/json_annotation.dart';
import 'package:dart_square/shared.dart';

part 'transaction.g.dart';

@JsonSerializable()
class GetTransactionResponse {
  final List<SquareError> errors;
  final Transaction transaction;

  GetTransactionResponse({ this.errors, this.transaction });

  factory GetTransactionResponse.fromJson(Map<String, dynamic> json) => _$GetTransactionResponseFromJson(json);
  Map<String, dynamic> toJson() => _$GetTransactionResponseToJson(this);
}

@JsonSerializable()
class ListTransactionResponse {
  final List<SquareError> errors;
  final List<Transaction> transactions;
  final String cursor;

  ListTransactionResponse({ this.errors, this.transactions, this.cursor });

  factory ListTransactionResponse.fromJson(Map<String, dynamic> json) => _$ListTransactionResponseFromJson(json);
  Map<String, dynamic> toJson() => _$ListTransactionResponseToJson(this);
}

@JsonSerializable()
class VoidTransactionResponse {
  final List<SquareError> errors;

  VoidTransactionResponse({ this.errors });

  factory VoidTransactionResponse.fromJson(Map<String, dynamic> json) => _$VoidTransactionResponseFromJson(json);
  Map<String, dynamic> toJson() => _$VoidTransactionResponseToJson(this);
}